package com.heikohinz.testmsg;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.heikohinz.testmsg", "com.heikohinz.testmsg.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.heikohinz.testmsg", "com.heikohinz.testmsg.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.heikohinz.testmsg.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnabout = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnaddnewtopic = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lvwtopics = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtnewtopic = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtnickname = null;
public anywheresoftware.b4a.samples.httputils2.httputils2service _httputils2service = null;
public com.heikohinz.testmsg.starter _starter = null;
public com.heikohinz.testmsg.firebasemessaging _firebasemessaging = null;
public com.heikohinz.testmsg.frmmsg _frmmsg = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (frmmsg.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 40;BA.debugLine="Activity.LoadLayout(\"viewMain\")";
mostCurrent._activity.LoadLayout("viewMain",mostCurrent.activityBA);
 //BA.debugLineNum = 41;BA.debugLine="Activity.Title = \"Simple Message 1.1\"";
mostCurrent._activity.setTitle(BA.ObjectToCharSequence("Simple Message 1.1"));
 //BA.debugLineNum = 42;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 48;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 44;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 45;BA.debugLine="RefreshListView";
_refreshlistview();
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _btnabout_click() throws Exception{
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
 //BA.debugLineNum = 68;BA.debugLine="Sub btnAbout_Click";
 //BA.debugLineNum = 69;BA.debugLine="Dim sb As StringBuilder";
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 70;BA.debugLine="sb.Initialize";
_sb.Initialize();
 //BA.debugLineNum = 71;BA.debugLine="sb.Append(\"You can talk to your friends over diff";
_sb.Append("You can talk to your friends over different channels (topics). Just define a topic (open a group) and tell your friends the topic name."+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 72;BA.debugLine="sb.Append(\"Remove a topic by longtab on the list";
_sb.Append("Remove a topic by longtab on the list item."+anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 73;BA.debugLine="Msgbox(sb.ToString, \"Info\")";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToCharSequence(_sb.ToString()),BA.ObjectToCharSequence("Info"),mostCurrent.activityBA);
 //BA.debugLineNum = 74;BA.debugLine="End Sub";
return "";
}
public static String  _btnabout_longclick() throws Exception{
String _stoken = "";
 //BA.debugLineNum = 76;BA.debugLine="Sub btnAbout_LongClick";
 //BA.debugLineNum = 77;BA.debugLine="Dim sToken As String = CallSub(FirebaseMessaging,";
_stoken = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(mostCurrent._firebasemessaging.getObject()),"GetMyToken"));
 //BA.debugLineNum = 78;BA.debugLine="Msgbox(\"Your private user token is: \" & CRLF & sT";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToCharSequence("Your private user token is: "+anywheresoftware.b4a.keywords.Common.CRLF+_stoken),BA.ObjectToCharSequence("Info"),mostCurrent.activityBA);
 //BA.debugLineNum = 79;BA.debugLine="End Sub";
return "";
}
public static String  _btnaddnewtopic_click() throws Exception{
 //BA.debugLineNum = 57;BA.debugLine="Sub btnAddNewTopic_Click";
 //BA.debugLineNum = 58;BA.debugLine="Try";
try { //BA.debugLineNum = 59;BA.debugLine="SaveNickname";
_savenickname();
 //BA.debugLineNum = 60;BA.debugLine="CallSub2(FirebaseMessaging, \"AddTopic\", txtNewTo";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._firebasemessaging.getObject()),"AddTopic",(Object)(mostCurrent._txtnewtopic.getText()));
 //BA.debugLineNum = 61;BA.debugLine="txtNewTopic.Text = \"\"";
mostCurrent._txtnewtopic.setText(BA.ObjectToCharSequence(""));
 //BA.debugLineNum = 62;BA.debugLine="RefreshListView";
_refreshlistview();
 } 
       catch (Exception e7) {
			processBA.setLastException(e7); //BA.debugLineNum = 64;BA.debugLine="ToastMessageShow(LastException, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getObject()),anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 31;BA.debugLine="Private btnAbout As Button";
mostCurrent._btnabout = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Private btnAddNewTopic As Button";
mostCurrent._btnaddnewtopic = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private lvwTopics As ListView";
mostCurrent._lvwtopics = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Private txtNewTopic As EditText";
mostCurrent._txtnewtopic = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Private txtNickname As EditText";
mostCurrent._txtnickname = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _lvwtopics_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 81;BA.debugLine="Sub lvwTopics_ItemClick (Position As Int, Value As";
 //BA.debugLineNum = 82;BA.debugLine="SaveNickname";
_savenickname();
 //BA.debugLineNum = 83;BA.debugLine="FrmMsg.s_Topic = Value";
mostCurrent._frmmsg._s_topic = BA.ObjectToString(_value);
 //BA.debugLineNum = 84;BA.debugLine="StartActivity(FrmMsg)";
anywheresoftware.b4a.keywords.Common.StartActivity(processBA,(Object)(mostCurrent._frmmsg.getObject()));
 //BA.debugLineNum = 85;BA.debugLine="End Sub";
return "";
}
public static String  _lvwtopics_itemlongclick(int _position,Object _value) throws Exception{
String _stopic = "";
 //BA.debugLineNum = 87;BA.debugLine="Sub lvwTopics_ItemLongClick (Position As Int, Valu";
 //BA.debugLineNum = 88;BA.debugLine="Dim sTopic As String = Value";
_stopic = BA.ObjectToString(_value);
 //BA.debugLineNum = 89;BA.debugLine="If Msgbox2(\"Really remove this topic?\", \"Remove \"";
if (anywheresoftware.b4a.keywords.Common.Msgbox2(BA.ObjectToCharSequence("Really remove this topic?"),BA.ObjectToCharSequence("Remove "+_stopic),"OK","Cancel","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 90;BA.debugLine="CallSub2(FirebaseMessaging, \"RemoveTopic\", sTopi";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._firebasemessaging.getObject()),"RemoveTopic",(Object)(_stopic));
 //BA.debugLineNum = 91;BA.debugLine="RefreshListView";
_refreshlistview();
 };
 //BA.debugLineNum = 93;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        anywheresoftware.b4a.samples.httputils2.httputils2service._process_globals();
main._process_globals();
starter._process_globals();
firebasemessaging._process_globals();
frmmsg._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _refreshlistview() throws Exception{
String _stopic = "";
anywheresoftware.b4a.objects.collections.List _li = null;
int _i = 0;
 //BA.debugLineNum = 99;BA.debugLine="Sub RefreshListView";
 //BA.debugLineNum = 100;BA.debugLine="Dim sTopic As String";
_stopic = "";
 //BA.debugLineNum = 101;BA.debugLine="Dim li As List = Starter.lstTopics";
_li = new anywheresoftware.b4a.objects.collections.List();
_li = mostCurrent._starter._lsttopics;
 //BA.debugLineNum = 102;BA.debugLine="txtNickname.Text = li.Get(0)";
mostCurrent._txtnickname.setText(BA.ObjectToCharSequence(_li.Get((int) (0))));
 //BA.debugLineNum = 103;BA.debugLine="lvwTopics.Clear";
mostCurrent._lvwtopics.Clear();
 //BA.debugLineNum = 104;BA.debugLine="For i = 1 To li.Size - 1";
{
final int step5 = 1;
final int limit5 = (int) (_li.getSize()-1);
_i = (int) (1) ;
for (;_i <= limit5 ;_i = _i + step5 ) {
 //BA.debugLineNum = 105;BA.debugLine="sTopic = li.Get(i)";
_stopic = BA.ObjectToString(_li.Get(_i));
 //BA.debugLineNum = 106;BA.debugLine="lvwTopics.AddSingleLine2(sTopic, sTopic)";
mostCurrent._lvwtopics.AddSingleLine2(BA.ObjectToCharSequence(_stopic),(Object)(_stopic));
 }
};
 //BA.debugLineNum = 108;BA.debugLine="End Sub";
return "";
}
public static String  _savenickname() throws Exception{
 //BA.debugLineNum = 95;BA.debugLine="Sub SaveNickname";
 //BA.debugLineNum = 96;BA.debugLine="CallSub2(Starter, \"SaveNickname\", txtNickname.Tex";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SaveNickname",(Object)(mostCurrent._txtnickname.getText()));
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _txtnewtopic_enterpressed() throws Exception{
 //BA.debugLineNum = 53;BA.debugLine="Sub txtNewTopic_EnterPressed";
 //BA.debugLineNum = 54;BA.debugLine="btnAddNewTopic_Click";
_btnaddnewtopic_click();
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
}
