﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public s_Topic As String
	Private tmrUpdate As Timer
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private txtSendMsg As EditText
	Private webMsg As WebView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("viewMsg")
	Activity.Title = s_Topic
	tmrUpdate.Initialize("tmrUpdate", 1000)
	tmrUpdate.Enabled = True
End Sub

Sub Activity_Resume
	ShowMessages
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub txtSendMsg_EnterPressed
	SendMessage
End Sub

Sub tmrUpdate_Tick
	If Starter.b_NewMsgArrived Then 
		Starter.b_NewMsgArrived = False
		ShowMessages
	End If
End Sub

Sub SendMessage
	Dim sName As String = Starter.s_Nickname
	If sName = "" Then sName = "anonym"
	SendMessage2(s_Topic, s_Topic & " - " & sName, txtSendMsg.Text)
End Sub

Private Sub SendMessage2(topic As String, title As String, body As String)
	Dim Job As HttpJob
	Job.Initialize("", Me)
	Dim sAdr As String = "/topics/" & topic ' $"/topics/${Topic}"$
	
	Dim m As Map = CreateMap("to": sAdr)
	Dim data As Map = CreateMap("title": title, "body": body)
	m.Put("data": data)
	Dim jg As JSONGenerator
	jg.Initialize(m)
	Job.PostString("https://fcm.googleapis.com/fcm/send", jg.ToString)
	Job.GetRequest.SetContentType("application/json")
	Job.GetRequest.SetHeader("Authorization", "key=" & Starter.API_KEY)
	
	Wait For (Job) JobDone(Job As HttpJob)
	If Job.Success Then
		Log(Job.GetString)
	End If
	Job.Release

	txtSendMsg.Text = ""
End Sub

Sub ShowMessages
	Dim sDir As String = File.DirInternal
	Dim sFilename As String = s_Topic & ".html"
	If File.Exists(sDir, sFilename) Then
		Dim sHTML As String = GetHTML(File.ReadString(sDir, sFilename))
		webMsg.LoadHtml(sHTML)
	End If
End Sub

Sub GetHTML(body As String) As String
	'with the onload JavaScript we scroll to the last message 
	Return "<html><header></header><body onload=""window.scrollTo(0,document.body.scrollHeight);"">" & body & "</body></html>"
End Sub


Sub webMsg_PageFinished (Url As String)
	
End Sub


