﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public const API_KEY As String = "[your Api_Key]"
	Public s_Topic As String
	Public lstTopics As List 'List with all topics you are interested in (.Get(0) = nickname)
	Public smiley As Bitmap
	Public s_Nickname, s_LastName As String
	Public b_NewMsgArrived As Boolean
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	LoadTopicList
	smiley = LoadBitmapResize(File.DirAssets, "smiley.png", 24dip, 24dip, False)
	CallSubDelayed(FirebaseMessaging, "SubscribeToTopics")
End Sub

Sub Service_Start (StartingIntent As Intent)
	

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub LoadTopicList
	lstTopics.Initialize
	If File.Exists(File.DirInternal, "_topics.txt") Then
		lstTopics = File.ReadList(File.DirInternal, "_topics.txt")
		If lstTopics.Size > 0 Then s_Nickname = lstTopics.Get(0)
	Else
		lstTopics.Add("anonymus")
	End If
End Sub

Sub SaveTopicList
	File.WriteList (File.DirInternal, "_topics.txt", lstTopics)
End Sub

Sub SaveNickname(nickname As String)
	s_Nickname = nickname
	lstTopics.Set(0, nickname)
	SaveTopicList
End Sub


